#include <math.h>
#include "transform.h"

double DotProduct(tVector v1, tVector v2) { return (v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2]); }
double Length(tVector v1) { return sqrt(DotProduct(v1,v1)); }
void Normalize(tVector *v1) 
{ int i; double l; l=Length(*v1); if (l<0.000001) return; for (i=0;i<3;i++) (*v1)[i]/=l; (*v1)[3]=0; }

void CrossProduct(tVector v1, tVector v2, tVector *res) {
  (*res)[0]=v1[1]*v2[2]-v1[2]*v2[1];
  (*res)[1]=v1[2]*v2[0]-v1[0]*v2[2];
  (*res)[2]=v1[0]*v2[1]-v1[1]*v2[0];
  (*res)[3]=0;
  return;
}

